;
; Definiert ein _memcpy
;
;
; Kopiert (akku) Bytes von der zweitobersten Adresse im Stack zur
; obersten Adresse im Stack
;
; Dies ist kein ausfuehrbares Assemblerprogramm sondern nur eine
; Include-Datei
;

_memcpy:
	store _memcpyvar + 4
	and #$fffffffc
	call _memcpy_4
	load _memcpyvar + 4
	and #$03
	bzero _endmemcpy

_memcpyloop:
	store _memcpyvar
	swap
	dup
	loadb
	swap
	dup
	storeb
	load # 1
	add
	push
	swap
	load # 1
	add
	push
	swap
	load # -1
	add _memcpyvar
	bnzro _memcpyloop

_endmemcpy:
	pop
	pop
	ret

;
; daten
;

_memcpyvar:
	data 0, 0

;
; Kopierroutine fuer ein vielfaches von 4, muss aber groesser 0 sein
;

_memcpy_4:
	store _memcpyvar
	swap
	dup
	load
	swap
	dup
	store
	load # 4
	add
	push
	swap
	load # 4
	add
	push
	swap
	load # -4
	add _memcpyvar
	bnzro _memcpy_4
	ret
